VERSION 5.00
Begin VB.Form FRunOnce 
   Caption         =   "RunOnce Test"
   ClientHeight    =   1485
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2400
   LinkTopic       =   "Form1"
   ScaleHeight     =   1485
   ScaleWidth      =   2400
   StartUpPosition =   3  'Windows Default
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Label1"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   1395
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "FRunOnce"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *********************************************************************
'  Copyright 1998 Karl E. Peterson, All Rights Reserved
'  http://www.mvps.org/vb
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

' Maintain reference to registry class.
Private reg As CRegSettings

Private Sub Form_Load()
   Dim msg As String
   Dim win As Long
   
   ' Set defaults for registry access.
   Set reg = New CRegSettings
   reg.Company = "VBPJ"
   reg.AppName = "RunOnce QA9903"
   
   ' Check to see what value(s) were stored
   ' last time we shut down.
   msg = reg.GetSetting(Section:="BootParams", _
         Key:="Shutdown", _
         Default:="(n/a)")
   win = CLng(reg.GetSetting(Section:="BootParams", _
         Key:="WindowState", _
         Default:=CStr(vbNormal)))
   
   ' Clear last stored value(s) from registry.
   reg.DeleteSetting "BootParams", "Shutdown"
   reg.DeleteSetting "BootParams", "WindowState"
   
   ' Display message to simulate restoring
   ' similar condition to last shutdown.
   If msg <> "(n/a)" Then
      Label1.Caption = "This program was running " & _
         "the last time you shut down your computer. " & _
         vbCrLf & "Terminated: " & msg
   Else
      Label1.Caption = "You shut this program down " & _
         "normally the last time you ran it."
   End If
   
   ' Restore previous/default WindowState
   Me.WindowState = win
   
   ' Clear ugly default icon.
   Set Me.Icon = Nothing
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
   If UnloadMode = vbAppWindows Then
      ' Windows is shutting down. Store appname
      ' and command line for execution next boot.
      Call RunNextBoot(AppName:="VBPJ QA9903", _
         CmdLine:=App.Path & "\" & App.EXEName, _
         ThisUserOnly:=True, RunEveryBoot:=False)
      ' Store some info about how to resume.
      reg.SaveSetting Section:="BootParams", _
         Key:="Shutdown", _
         Setting:=Format$(Now, "long date")
      reg.SaveSetting Section:="BootParams", _
         Key:="WindowState", _
         Setting:=CStr(Me.WindowState)
   End If
End Sub

Private Sub Form_Resize()
   On Error Resume Next
   Label1.Width = Me.ScaleWidth - Label1.Left * 2
End Sub
